<%@ Page Language="C#" %>
<%@ Import Namespace="OSGeo.MapGuide" %>

<script runat="server">
    MgGeometry getGeometry(String district, MgFeatureService featureService)
    {
        MgFeatureQueryOptions districtQuery = new MgFeatureQueryOptions();
        districtQuery.SetFilter("Autogenerated_SDF_ID = " + district);
        MgResourceIdentifier districtId = new MgResourceIdentifier("Library://Samples/Sheboygan/Data/VotingDistricts.FeatureSource");
        MgFeatureReader featureReader = featureService.SelectFeatures(districtId, "VotingDistricts", districtQuery);

        featureReader.ReadNext();
        MgByteReader geometryBytes = featureReader.GetGeometry("Data");
        MgAgfReaderWriter agfReader = new MgAgfReaderWriter();
        MgGeometry districtGeometry = agfReader.Read(geometryBytes);

        return districtGeometry;
        
    }
</script>
<%
    String sessionId = Request.Form.Get("SESSION");
    String district = Request.Form.Get("DISTRICT");
    String name = Request.Form.Get("NAME");

    string realPath = Request.ServerVariables["APPL_PHYSICAL_PATH"];
    String configPath = realPath + "webconfig.ini";
    MapGuideApi.MgInitializeWebTier(configPath);

    MgUserInformation userInfo = new MgUserInformation(sessionId);
    MgSiteConnection siteConnection = new MgSiteConnection();
    siteConnection.Open(userInfo);

    MgResourceService resService = (MgResourceService)siteConnection.CreateService(MgServiceType.ResourceService);
    MgFeatureService featureService = (MgFeatureService)siteConnection.CreateService(MgServiceType.FeatureService);

    MgMap map = new MgMap();
    map.Open(resService, "Sheboygan");

    //Get Geometry object: districtGeometry
    MgGeometry districtGeometry = getGeometry(district, featureService);

    MgFeatureQueryOptions nameQuery = new MgFeatureQueryOptions();
    nameQuery.SetFilter("RNAME LIKE '" + name + "%'");
    nameQuery.SetSpatialFilter("SHPGEOM", districtGeometry, MgFeatureSpatialOperations.Inside);

    MgResourceIdentifier parcelId = new MgResourceIdentifier("Library://Samples/Sheboygan/Data/Parcels.FeatureSource");
    MgFeatureReader featureReader = featureService.SelectFeatures(parcelId, "Parcels", nameQuery);

    ArrayList list = new ArrayList();
    while (featureReader.ReadNext())
    {
        list.Add(featureReader.GetString("RPROPAD"));
    }

    //Highlight the query result on the map
    MgSelection selection = new MgSelection(map);
    MgLayer layer = map.GetLayers().GetItem("Parcels");
    featureReader = featureService.SelectFeatures(parcelId, "Parcels", nameQuery);
    selection.AddFeatures(layer, featureReader, 0);
    String selectionXML = selection.ToXml();
  
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Make Query</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <meta http-equiv="content-script-type" content="text/javascript" />
    <meta http-equiv="content-style-type" content="text/css" />
    <link href="styles/globalstyles.css" rel="stylesheet" type="text/css" />
    <link href="styles/alphastyles.css" rel="stylesheet" type="text/css" />

    <script type="text/javascript">
        function onPageLoad() {
            var selectionXML = '<%= selectionXML %>';
            parent.parent.SetSelectionXML(selectionXML);         
        }
    </script>

</head>
<body class="AppFrame" onload="onPageLoad()">
    <strong>The following are the query results: </strong>
    <ul>
        <%
            for (int i = 0; i < list.Count; i++)
            {
                String address = list[i].ToString();
                if (address != "")
                {
                    Response.Write("<li>" + list[i].ToString() + "</li>\n");
                }
            }
        %>
    </ul>
</body>
</html>
